Build a quoted Midnight borrow
Builds a borrow of an exact loan-asset amount (unit: assets) or an exact debt-unit amount (unit: units; debt units are the borrow-side unit, redeemable for one loan-token base unit at market maturity) against the open offers of the selected market.
Set guard to slippage relative to the API quote, max_rate for a maximum WAD-scaled per-second simple rate, or the matching absolute bound (max_units for an assets amount, min_assets for a units amount). With slippage, the guarded seller price is also never below the price implied by a 100% fixed APR to maturity, and quotes below that floor are rejected. When referral_fee is present, its recipient must differ from the borrowing account. Add collateral_supplies and funding to supply one or more configured collaterals in the same atomic action. Native or automatic funding applies only to the wrapped-native collateral portion; all other collateral remains ERC-20 funded. Native funding is rejected with 400 VALIDATION_FAILED when no supplied collateral is the chain's wrapped-native token, including on chains without a wrapped-native token. On chains with a wrapped-native token, automatic funding remains accepted when no supplied collateral is wrapped native.
Authorization
ApiKeyAuth Send your Morpho-issued key on every action request. JWKS needs no key on every host; public documentation needs no key.
In: header
Path Parameters
Midnight market selector formatted as <chain_id>:<market_id>. The colon may be sent literally or as %3A.
^(?:[1-9][0-9]{0,14}|[1-8][0-9]{15}|900[0-6][0-9]{12}|90070[0-9]{11}|90071[0-8][0-9]{10}|900719[0-8][0-9]{9}|9007199[0-1][0-9]{8}|90071992[0-4][0-9]{7}|900719925[0-3][0-9]{6}|9007199254[0-6][0-9]{5}|90071992547[0-3][0-9]{4}|9007199254740[0-8][0-9]{2}|90071992547409[0-8][0-9]{1}|9007199254740990|9007199254740991):0x[0-9a-fA-F]{64}$Request Body
application/json
TypeScript Definitions
Use the request body type in TypeScript.
Borrow only, or supply collateral and borrow in one atomic action.
Borrow only, or supply collateral and borrow in one atomic action.
Response Body
application/json
application/json
application/json
application/json
application/json
application/json
application/json
curl -X POST "https://example.com/v0/actions/midnight/markets/{market-selector}/borrow" \ -H "Content-Type: application/json" \ -d '{ "account": "0x6aBB9Aeb93e9aF04c8D9FD2b84BF6ca8EDC3eAf2", "amount": { "unit": "assets", "value": "1000000" }, "guard": { "type": "slippage", "bps": 50 } }'{ "data": { "action_id": "act_0123456789abcdef0123456789abcdef", "status": "prepared", "chain_id": 8453, "account": "0x6aBB9Aeb93e9aF04c8D9FD2b84BF6ca8EDC3eAf2", "expires_at": 1760001800, "market": { "id": "0xcdea4ca06837feca3026b23a95f0bd96c3eabdc77d1211472ce0346fcc200649", "loan_asset": { "address": "0x4200000000000000000000000000000000000006" }, "collaterals": [ { "address": "0x2Ae3F1Ec7F1F5012CFEab0185bfc7aa3cf0DEc22" }, { "address": "0xFa750DD0099eAdB72d401244De73ce7B89edf90F" } ] }, "action": "midnight.borrow", "amount": { "unit": "assets", "value": "1000000" }, "guard": { "type": "slippage", "bps": 50 }, "quote": { "average_best_price_wad": "999701089374277091", "average_worst_price_wad": "994702583927405705", "available_assets": "1000000", "available_units": "1000299", "offer_count": 1 }, "max_borrow_units": "1005326", "calls": [ { "id": "call_0", "kind": "borrow", "to": "0x0bF30B530f816a619C3F28a3b9f44C441122555D", "data": "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", "value": "0" } ], "simulation": { "status": "success", "block": { "number": "21000000", "timestamp": 1760000000 }, "wallet_changes": [ { "asset": { "type": "erc20", "address": "0x4200000000000000000000000000000000000006" }, "difference": "1000000" } ], "position_changes": { "credit_units": "0", "debt_units": "1000299" }, "effects": { "borrowed_assets": "1000000", "borrowed_units": "1000299", "referral_fee_assets": "0" } }, "collateral_supplies": [] }}{ "error": { "code": "REQUEST_ABORTED", "message": "string", "details": [ { "code": "string", "message": "string", "path": [ "string" ], "rule": "string", "details": { "min_assets": "string", "loan_token": "string" } } ], "request_id": "string" }}{ "error": { "code": "MARKET_NOT_FOUND", "message": "string", "details": [ { "code": "string", "message": "string", "path": [ "string" ], "rule": "string", "details": { "min_assets": "string", "loan_token": "string" } } ], "request_id": "string" }}{ "error": { "code": "PAYLOAD_TOO_LARGE", "message": "string", "details": [ { "code": "string", "message": "string", "path": [ "string" ], "rule": "string", "details": { "min_assets": "string", "loan_token": "string" } } ], "request_id": "string" }}{ "error": { "code": "ACTION_UNSUPPORTED", "message": "This action is not supported.", "details": null, "request_id": "req_0123456789abcdef0123456789abcdef" }}{ "error": { "code": "INTERNAL_ERROR", "message": "string", "details": [ { "code": "string", "message": "string", "path": [ "string" ], "rule": "string", "details": { "min_assets": "string", "loan_token": "string" } } ], "request_id": "string" }}{ "error": { "code": "CONTRACT_CODE_MISSING", "message": "string", "details": [ { "code": "string", "message": "string", "path": [ "string" ], "rule": "string", "details": { "min_assets": "string", "loan_token": "string" } } ], "request_id": "string" }}POSTBuild a direct Midnight collateral supply
Builds and simulates a direct collateral supply to one configured Midnight collateral. POST /v0/actions/midnight/markets/{market-selector}/supply-collateral.
POSTPublish Midnight borrow offers with optional collateral supply
Builds and simulates the calls that publish a public set of borrow offers priced by offers.type (price for a fixed price per unit, rate for an interest rate).